<?php
$dataFile = 'cookies.json';
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];

$email = isset($_GET['email']) ? $_GET['email'] : null;
$auth_session = null;

if ($email && isset($data[$email])) {
    $auth_session = $data[$email]['cookie'];
} else {
    echo json_encode(['error' => "Email not found"]);
    exit;
}

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Get the prompt from the POST request
    $prompt = isset($_POST['prompt']) ? $_POST['prompt'] : '';

$width = isset($_POST['width']) ? intval($_POST['width']) : 1024;
    $height = isset($_POST['height']) ? intval($_POST['height']) : 1024;


$prompt = str_replace(["\r", "\n"], '', $prompt);
$prompt= str_replace("'",'"',$prompt);
 
    // Escape special characters in the prompt
    $escapedPrompt = addslashes($prompt);

    // Initialize cURL
    $curl = curl_init();

    curl_setopt_array($curl, [
        CURLOPT_URL => 'https://stablediffusionweb.com/api/generate.image.addTasks?batch=1',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => '{"0":{"json":{"model":"SD-XL","prompt":"' . $escapedPrompt . '","negative_prompt":"","steps":40,"style":"Default","width":'.$width.',"height":'.$height.',"number_of_images":1,"cfg_scale":7,"image_cfg_scale":null,"seed":null,"input_image":null},"meta":{"values":{"image_cfg_scale":["undefined"],"seed":["undefined"],"input_image":["undefined"]}}}}',
        CURLOPT_COOKIE => 'NEXT_LOCALE=en; auth_session=' . $auth_session,
        CURLOPT_HTTPHEADER => [
            'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
            'Accept-Encoding: gzip, deflate, br, zstd',
            'Content-Type: application/json',
            'sec-ch-ua-platform: "Android"',
            'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
            'sec-ch-ua-mobile: ?1',
            'origin: https://stablediffusionweb.com',
            'x-requested-with: mark.via.gp',
            'sec-fetch-site: same-origin',
            'sec-fetch-mode: cors',
            'sec-fetch-dest: empty',
            'referer: https://stablediffusionweb.com/app/image-generator',
            'accept-language: en-US,en;q=0.9',
            'priority: u=1, i',
        ],
    ]);

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
        echo json_encode(['error' => 'cURL Error #: ' . $err]);
    } else {
        echo $response;
    }
} else {
    echo json_encode(['error' => 'Invalid Request Method']);
}
?>
