<?php

// Load or initialize the JSON file
$dataFile = 'cookies.json';
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];

// Check if the request is POST
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $email = $_POST['email'];
    $password = $email; // Same as email
    $name = $email;

  

    $curl = curl_init();

    curl_setopt_array($curl, [
        CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.signup?batch=1',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_HEADER => true,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => '{"0":{"json":{"email":"' . $email . '","password":"' . $password . '","name":"' . $name . '","callbackUrl":"https://stablediffusionweb.com/auth/verify"}}}',
        CURLOPT_COOKIE => 'NEXT_LOCALE=en',
    CURLOPT_HTTPHEADER => [
        'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
        'Accept-Encoding: gzip, deflate, br, zstd',
        'Content-Type: application/json',
        'sec-ch-ua-platform: "Android"',
        'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
        'sec-ch-ua-mobile: ?1',
        'origin: https://stablediffusionweb.com',
        'x-requested-with: mark.via.gp',
        'sec-fetch-site: same-origin',
        'sec-fetch-mode: cors',
        'sec-fetch-dest: empty',
        'referer: https://stablediffusionweb.com/auth/signup',
        'accept-language: en-US,en;q=0.9',
        'priority: u=1, i',
    ],
    ]);

    $response = curl_exec($curl);
    $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
    $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
    $headers = substr($response, 0, $header_size);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err || $http_code !== 200) {
        die("Error: " . ($err ?: $response));
    }

    // Extract auth_session cookie
    if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
        $auth_session = $matches[1];
        $data[$email] = ['cookie' => $auth_session];
        file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
        echo "Signup successful! Auth Session Cookie saved.<br>";
        echo '<a href="index.html">Go Back</a>';
    } else {
        echo "No auth_session cookie found.";
    }
} else {
    echo "Invalid request.";
}
