<?php
header("Content-Type:application/json");

if (isset($_GET['id'])) {
    $videoId = $_GET['id'];

    $curl = curl_init();

    curl_setopt_array($curl, [
        CURLOPT_URL => 'https://api.vidiq.com/proxy/youtube/v3/videos?part=statistics%2Csnippet%2CcontentDetails%2Cstatus&id=' . $videoId,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_HTTPHEADER => [
            'User-Agent: okhttp/4.12.0',
            'Accept-Encoding: gzip',
             'authorization: Bearer UKP!83cb1f65-d294-4391-89da-a27e4b2546b2!44480d59-7a64-4143-b6e4-cbfcffb5f954', //Replace with your api key
        ],
    ]);

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
      // Error handling: Send back an error message in JSON
      echo json_encode(['error' => 'cURL Error #:' . $err]);
    } else {
        // Send the response back as JSON
      echo $response;
    }
} else {
  // Error handling if id is not set in GET request
  echo json_encode(['error' => 'Video ID not provided.']);
}
?>