<?php

$dataFile = 'apis/cookies.json';
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>YouTube SEO Tool</title>
<link rel="stylesheet" href="style.css?id=hh3">
</head>
<body>
<center>
<button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('https://chatgpt.com/share/67c3fb34-f410-8011-bede-49b52174e596', '_blank', 'noopener,noreferrer')">
Thumbnail Lines</button>
<button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('https://chatgpt.com/share/67c3d89a-81b8-8011-b5f0-095dc5502ab7', '_blank', 'noopener,noreferrer')">
Book Mockup</button>
<div class="container">
        <form style="display: block;" id="inputForm">
            <label for="input">Enter YouTube Link for transcribe or Search Query:</label>
            <input type="text" id="input" name="input" placeholder="Enter search query or yt link..." required>
            <button type="button" id="searchBtn">keywords</button>
            <button type="button" id="extractInfoBtn">Tags</button>
             <button type="button" class="transcript-btn" data-api="apis/ytTranscript.php">TC- ytFree</button>
             <button type="button" class="transcript-btn" data-api="apis/hindiTC.php">TC- Eng to hindi</button>
             <button type="button" class="transcript-btn" data-api="apis/englishTC.php">TC- english</button>
             <button type="button" class="transcript-btn" data-api="apis/Outcast.php">TC- OutCastAi</button>
             <button type="button" class="transcript-btn" data-api="apis/notegpt.php">TC- NoteGPT</button>
             <button type="button" class="transcript-btn" data-api="apis/KomeAi.php">TC- KomeAi</button>
             <button type="button" class="transcript-btn" data-api="apis/taqticai.php">TC- TaqTicAi</button>
        </form>
        <div id="loading-text-yt" style="display: none;">Loading...</div>
        <div id="resultContainer"></div>
        <div id="extractionContainer"></div>
        <div id="descriptionContainer"></div>

         <div id="transcriptContainer" style="display: none;">
             <div id="thumbnailContainer" class="thumbnail"></div> <!-- Thumbnail will be inserted here -->
              <div id="transcriptDisplayContainer" style="display:none;">
                   <div id="loading-transcript" style="display:none;">Loading...</div>
                    <h3 id="transcriptTitle"></h3>
                     <textarea id="transcriptTextarea" rows="10" readonly></textarea>
                     <input type="text" id="transcriptFileName" placeholder="Enter transcript file name" class="download-input">
                    <button id="copyTranscriptBtn" onclick="copyTranscript('transcriptTextarea')">Copy Transcript</button>
                     <button id="downloadTranscriptBtn" onclick="downloadTranscript('transcriptTextarea', 'transcriptFileName')">Download Transcript</button>
              </div>
         </div>
    </div>
<div class="book-container">
      <h2>Book Title, Tags Generator</h2>
      <form id="description-form">
           <label for="channel-select">Select Your Youtube Channel:</label>
          <select id="channel-select" name="channel-select">
            <option value="">AudioBook Legends</option>
            <option value="1">American AudioBooks</option>
             <option value="2">Mindset</option>
              <option value="3">The Lost Legends</option>
               <option value="4">Money Mind AudioBooks</option>
                <option value="5">Channel 5</option>
                 <option value="6">Channel 6</option>
          </select>
            <label for="book-name">Book Title:</label>
            <input type="text" id="book-name" name="book-name" required>
             <label for="book-author">Author(Optional):</label>
            <input type="text" id="book-author" name="book-author">
            <button type="submit">Generate Description</button>
        </form>
        <div id="description-area" style="display: none;">
            <h2>Generated Description</h2>
            <pre id="generated-description"></pre>
            <button id="copy-button">Copy to Clipboard</button>
        </div>
          <div id="loading-area" style="display:none;">
              Generating description...
           </div>
        <div id="error-area" style="display: none; color: red;">
          </div>
    </div>
</center>
   
<script>

    const inputField = document.getElementById('input');
    const resultContainer = document.getElementById('resultContainer');
    const transcriptContainer = document.getElementById('transcriptContainer');
    const thumbnailContainer = document.getElementById('thumbnailContainer');
    const extractionContainer = document.getElementById('extractionContainer');
    const descriptionContainer = document.getElementById('descriptionContainer');

   //Transcript container
     const transcriptDisplayContainer = document.getElementById('transcriptDisplayContainer');
    const transcriptTextarea = document.getElementById('transcriptTextarea');
    const transcriptTitle = document.getElementById('transcriptTitle');
      const loadingTranscript = document.getElementById('loading-transcript');


    //Book description elements
    const bookDescriptionForm = document.getElementById('description-form');
    const generatedDescriptionDiv = document.getElementById('description-area');
    const errorArea = document.getElementById('error-area');
    const generatedDescription = document.getElementById('generated-description');
    const copyButton = document.getElementById('copy-button');
    const loadingArea = document.getElementById('loading-area');
    const channelSelect = document.getElementById('channel-select');

    // Loading text
    const loadingTextYT = document.getElementById('loading-text-yt');

   inputField.addEventListener('input', function () {
         resultContainer.innerHTML = '';
         extractionContainer.innerHTML = '';
         descriptionContainer.innerHTML = '';
        const input = inputField.value.trim();
        if (input && !isValidYouTubeLink(input)) {
            loadingTextYT.style.display = 'block'; // Show loading
            fetchSearchQueries(input);

            transcriptContainer.style.display = 'none';
        } else if(input && isValidYouTubeLink(input)){
             transcriptContainer.style.display = 'none';
               fetchTranscript(input)
        }else{
           loadingTextYT.style.display = 'none'; // hide loading
             transcriptContainer.style.display = 'none';
        }
    });


    document.getElementById('searchBtn').addEventListener('click', function () {
        const input = inputField.value.trim();
        if (input && !isValidYouTubeLink(input)) {
            loadingTextYT.style.display = 'block'; // Show loading
            fetchSearchQueries(input);
        } else {
             alert('Please enter a search query.');
        }
    });

    document.getElementById('extractInfoBtn').addEventListener('click', function () {
            const input = inputField.value.trim();
            if (input && isValidYouTubeLink(input)) {
                loadingTextYT.style.display = 'block'; // Show loading
                fetchVideoInfo(input);
                 resultContainer.innerHTML = '';
            } else {
                alert('Please enter a valid YouTube link.');
            }
        });


    function isValidYouTubeLink(link) {
        const youtubeUrlPattern = /^(https?:\/\/)?(www\.)?(youtube\.com|youtu\.be)\/.+$/;
        return youtubeUrlPattern.test(link);
    }

  function fetchTranscript(link) {
        const videoId = extractVideoId(link);
        if (videoId) {
             fetchThumbnail(videoId);
             transcriptContainer.style.display = 'block';

          // Add event listeners to transcript buttons
             const transcriptButtons = document.querySelectorAll('.transcript-btn');
                transcriptButtons.forEach(button => {
                 button.onclick =  function() {
                     const apiEndpoint = this.getAttribute('data-api');
                      fetchAndDisplayTranscript(apiEndpoint, videoId);
                    };
                });

       }
    }

   function fetchAndDisplayTranscript(apiEndpoint, videoId) {
        transcriptDisplayContainer.style.display = 'none';
        transcriptTextarea.value = '';
          loadingTranscript.style.display = 'block';

        fetch(`${apiEndpoint}?id=${videoId}`)
            .then(response => response.text())
            .then(data => {
                 loadingTranscript.style.display = 'none';
                transcriptTextarea.value = data;
                transcriptTitle.textContent = `Transcript: ${apiEndpoint.split('/').pop().replace('.php','')}`;
                 transcriptDisplayContainer.style.display = 'block';
            })
            .catch(error => {
                loadingTranscript.style.display = 'none';
                transcriptTextarea.value = 'Error fetching transcript';
                 transcriptTitle.textContent = `Transcript: ${apiEndpoint.split('/').pop().replace('.php','')}`;
                 transcriptDisplayContainer.style.display = 'block';
                 console.error('Error fetching transcript:', error);

            });
    }

    function fetchVideoInfo(link) {
           const videoId = extractVideoId(link);
           if (videoId) {
                fetchVideoData(videoId);
            }
    }


    function extractVideoId(link) {
        const regex = /(?:youtube\.com\/(?:[^\/]+\/.+\/|(?:v|e(?:mbed)?)\/|.*[?&]v=)|youtu\.be\/|youtube\.com\/shorts\/)([^"&?\/\s]{11})/;
        const matches = link.match(regex);
        return matches ? matches[1] : null;
    }

  function fetchThumbnail(videoId) {
        const thumbnailUrl = `https://img.youtube.com/vi/${videoId}/maxresdefault.jpg`;
        const imgElement = document.createElement('img');
        imgElement.src = thumbnailUrl;
        imgElement.alt = 'Video Thumbnail';
        imgElement.style.maxWidth = '100%';
        thumbnailContainer.innerHTML = ''; // Clear any existing content
        thumbnailContainer.appendChild(imgElement);
    }


    function copyTranscript(elementId) {
        const transcript = document.getElementById(elementId).value;
        navigator.clipboard.writeText(transcript)
            .then(() => {
                alert('Transcript copied to clipboard!');
            })
            .catch(err => {
                console.error('Failed to copy text: ', err);
            });
    }

     function downloadTranscript(elementId, filenameInputId) {
       const content = document.getElementById(elementId).value;
        let filename = document.getElementById(filenameInputId).value.trim();
         if(!filename){
            alert('Please enter file name.');
            return
         }

        const now = new Date();
        const timestamp = `${now.getFullYear()}${String(now.getMonth() + 1).padStart(2, '0')}${String(now.getDate()).padStart(2, '0')}_${String(now.getHours()).padStart(2, '0')}${String(now.getMinutes()).padStart(2, '0')}${String(now.getSeconds()).padStart(2, '0')}`;

         const finalFilename = `${filename}_${timestamp}.txt`;


        const element = document.createElement('a');
        const file = new Blob([content], { type: 'text/plain' });
        element.href = URL.createObjectURL(file);
        element.download = finalFilename;
        document.body.appendChild(element);
        element.click();
        document.body.removeChild(element);
    }


    function fetchSearchQueries(query) {
            fetch(`apis/searchapi.php?query=${encodeURIComponent(query)}`)
                .then(response => response.json())
                .then(data => {
                   loadingTextYT.style.display = 'none'; // Hide loading on success
                   if (Array.isArray(data)) {
                        const formattedItems = data.map(item => `<div class="result-line" onclick="copyLineToClipboard('${item}')">${item}</div>`).join('');
                         const resultHtml = `
                            <button class="copy-btn" onclick="copyAllToClipboard()">Copy All</button>
                            <div class="result-box">
                                ${formattedItems}
                            </div>
                        `;
                         resultContainer.innerHTML = resultHtml;
                     } else if (data && data.error) {
                            resultContainer.innerHTML = `<p>${data.error}</p>`;
                        } else {
                        resultContainer.innerHTML = '<p>No results found.</p>';
                        }

                })
                .catch(error => {
                   loadingTextYT.style.display = 'none'; // Hide loading on error
                    console.error("Error fetching search queries:", error);
                    resultContainer.innerHTML = '<p>Error fetching data from the API.</p>';
                });
        }

        function fetchVideoData(videoId) {
            fetch(`apis/ytApi.php?id=${videoId}`)
                .then(response => response.json())
                .then(data => {
                     loadingTextYT.style.display = 'none'; // Hide loading on success
                    if (data && data.items && data.items.length > 0) {
                        const video = data.items[0];
                        const title = video.snippet.title;
                        const tags = video.snippet.tags;
                        const description = video.snippet.description;
                         const thumbnailUrl = video.snippet.thumbnails.maxres ? video.snippet.thumbnails.maxres.url : video.snippet.thumbnails.high.url; // Fallback to high if maxres is not available

                          const tagItems = tags.map(tag => `<div class="result-line" onclick="copyLineToClipboard('${tag}')">${tag}</div>`).join('');
                        const infoHtml = `
                            <div class="info-box">
                                <h3>Title:</h3><div class="result-line" onclick="copyLineToClipboard('${title}')">${title}</div>
                                <br>
                                <h3>Tags:</h3>
                                ${tagItems}
                            </div>
                            <button class="copy-btn" onclick="copyAllTagsToClipboard()">Copy All Tags</button>
                             <div class="thumbnail">
                                    <img src="${thumbnailUrl}" alt="Video Thumbnail">
                            </div>
                         `;

                          const descriptionHtml = `<p style="white-space: pre-line;font-size: 16px; color:teal;">${description}</p>`;

                        extractionContainer.innerHTML = infoHtml;
                        descriptionContainer.innerHTML = descriptionHtml;


                    } else {
                        extractionContainer.innerHTML = '<p>Error fetching video information.</p>';
                         descriptionContainer.innerHTML = '';
                    }
                })
                .catch(error => {
                     loadingTextYT.style.display = 'none'; // Hide loading on error
                    console.error("Error fetching video data:", error);
                    extractionContainer.innerHTML = '<p>Error fetching video data from the API.</p>';
                     descriptionContainer.innerHTML = '';
                });
        }


        function copyAllTagsToClipboard() {
            const text = Array.from(document.querySelectorAll('.info-box .result-line'))
            .map(line => line.textContent.trim())
            .join('\n');

        navigator.clipboard.writeText(text)
            .then(() => {
                alert('Copied all tags to clipboard!');
            })
            .catch(err => {
                console.error('Failed to copy text: ', err);
            });
        }

    function copyLineToClipboard(text) {
        navigator.clipboard.writeText(text)
            .then(() => {
                alert('Copied line to clipboard!');
            })
            .catch(err => {
                console.error('Failed to copy text: ', err);
            });
    }

    function copyAllToClipboard() {
        const text = Array.from(document.querySelectorAll('.result-line'))
            .map(line => line.textContent.trim())
            .join('\n');

        navigator.clipboard.writeText(text)
            .then(() => {
                alert('Copied all results to clipboard!');
            })
            .catch(err => {
                console.error('Failed to copy text: ', err);
            });
    }

    //Book Description Form Submission
    bookDescriptionForm.addEventListener('submit', function(event) {
        event.preventDefault();

        const bookName = document.getElementById('book-name').value;
        const bookAuthor = document.getElementById('book-author').value;
          const selectedChannel = channelSelect.value;

         let apiUrl = 'apis/DescriptionGen.php';
         if (selectedChannel) {
            apiUrl = `apis/DescriptionGen${selectedChannel}.php`;
        }

        errorArea.style.display = 'none';
        generatedDescriptionDiv.style.display ='none';
        loadingArea.style.display = 'block';

        fetch(apiUrl, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded',
            },
            body: `book-name=${encodeURIComponent(bookName)}&book-author=${encodeURIComponent(bookAuthor)}`,
        })
       .then(response => {
          if(!response.ok){
            return response.text().then(text => {throw new Error(text)})
          }
          return response.json()
        })
        .then(data => {
          if(data.error) {
            errorArea.textContent = data.error;
            errorArea.style.display = 'block';
            return
          }
           loadingArea.style.display = 'none';
          generatedDescriptionDiv.style.display = 'block';
          generatedDescription.textContent = data.description;

        })
        .catch(error => {
            console.error('Error fetching description:', error);
          errorArea.textContent = "Error fetching description: " + error;
          errorArea.style.display = 'block';
           loadingArea.style.display = 'none';
        });
    });

    copyButton.addEventListener('click', function() {
        const descriptionText = generatedDescription.textContent;

        navigator.clipboard.writeText(descriptionText)
            .then(() => {
                alert('Description copied to clipboard!');
            })
            .catch(err => {
                console.error('Failed to copy text: ', err);
                alert('Failed to copy description.');
            });
    });
</script>
</body>
</html>


<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>YouTube SEO Tool</title>
    <link rel="stylesheet" href="style.css?id=u3jhhe">
    <style>
        .image-list {
            display: flex;
            flex-wrap: wrap;
            gap: 10px;
            flex-direction: column-reverse; /* New images on top */
        }

        .image-list img {
            max-width: 200px; /* Adjust as needed */
            height: auto;
            border: 1px solid #ddd;
            padding: 5px;
        }
    </style>
</head>
<body>
<center>
    <div class="container">
        <h2>Book Mockup Generator</h2>
        <div id="email-selector">
            <select id="emailDropdown">
                <option value="">Select an Email</option>
                <?php
                if (!empty($data)) {
                    foreach ($data as $email2 => $value) {
                        echo "<option value='" . htmlspecialchars($email2) . "'>" . htmlspecialchars($email2) . "</option>";
                    }
                }
                ?>
            </select>
            <button onclick="loadContent()">Go</button>
        </div>
        <div id="content-container">
           <div id="user-details-container" class="user-details"></div>
            <form id="imageForm">
                  <div id="prompt-container">
                          <textarea style="         background-color: #f0f0f0;
              padding: 20px;
             border-radius: 15px;
               box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
             width: 100%;height:250px;
              max-width: 600px;
              flex-direction: column;
              align-items: center;
              transition: transform 0.3s ease-in-out;
               margin-bottom: 20px;
            box-sizing: border-box;
           text-align: center;
    "  id="prompt" placeholder="Enter your prompt here" maxlength="500">A hyper realistic, highly detailed image of an old book mockup titled "The Secret Mindset Of Successful People". The book mockup should be placed on a natural bokeh background. In the footer of the book cover, include the Author name "AudioBook Legends" with an old typography which is clearly visible, also add relevant elements from title in the book cover.</textarea>
                           <div id="prompt-counter">0 / 500</div>
                            <div id="prompt-warning">Character limit exceeded.</div>
                           </div>
                    <div class="dimension-options">
                        <label for="dimensionPreset">Select Image Dimension:</label>
                            <select id="dimensionPreset">
                                <option value="custom">Custom Input</option>
                                 <option value="book">Book Mockup 1:1</option>
                                  <option value="thumbnail">Thumbnail 16:9</option>
                            </select>
                    </div>
               <div class="dimensions" style="display: flex; justify-content: center; align-items: center; margin-bottom: 15px;">
    <label for="width" style="margin-right: 5px;">Width:</label>
    <input type="number" id="width" placeholder="Width" value="1024" style="width: 80px; padding: 10px; margin: 0 5px; border: none; border-radius: 10px; box-sizing: border-box; background: #e0e0e0; box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff; outline: none;">
     <label for="height" style="margin-left: 5px; margin-right: 5px;">Height:</label>
    <input type="number" id="height" placeholder="Height" value="1024" style="width: 80px; padding: 10px; margin: 0 5px; border: none; border-radius: 10px; box-sizing: border-box; background: #e0e0e0; box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff; outline: none;">
</div>
                 <!-- Number of Images Select -->
                <div class="image-number-options">
                    <label for="numImages">Number of Images:</label>
                    <select id="numImages">
                        <option value="1">1</option>
                        <option value="2">2</option>
                        <option value="3">3</option>
                        <option value="4">4</option>
                        <option value="5">5</option>
                    </select>
                </div>
                <button type="submit">Generate Image</button>
                <div id="status"></div>
            </form>
            <div id="image-container" class="image-list"></div>
            <div id="history-container"></div>
        </div>
    </div>
</center>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>


<script>
    let promptTextarea = null; // Declare promptTextarea outside loadContent
    let promptCounter = null;
    let promptWarning = null;
    let widthInput = null;
    let heightInput = null;
    let dimensionPresetDropdown = null;
    function updatePromptCounter() {
        if(!promptTextarea) return; // Check if textarea exists
        const currentLength = promptTextarea.value.length;
        promptCounter.textContent = currentLength + ' / 500';

        if (currentLength > 500) {
            promptWarning.style.display = 'block';
        } else {
            promptWarning.style.display = 'none';
        }
    }
    function updateDimensionInputs(preset) {
         if(!widthInput || !heightInput) return; // Check

        switch (preset) {
            case 'book':
                widthInput.value = 1024;
                heightInput.value = 1024;
                break;
            case 'thumbnail':
                widthInput.value = 1280;
                heightInput.value = 720;
                break;
            case 'custom':
                break;
        }
    }
    const contentContainer = document.getElementById('content-container');
    let currentEmail = null;
    function loadContent() {
        const emailDropdown = document.getElementById('emailDropdown');
        const selectedEmail = emailDropdown.value;
        if (!selectedEmail) return;
        currentEmail = selectedEmail;
        contentContainer.classList.add('show');
         contentContainer.innerHTML = `
            <div id="user-details-container" class="user-details"></div>
            <form id="imageForm">
                  <div id="prompt-container">
                          <textarea style="         background-color: #f0f0f0;
              padding: 20px;
             border-radius: 15px;
               box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
             width: 100%;height:250px;
              max-width: 600px;
              flex-direction: column;
              align-items: center;
              transition: transform 0.3s ease-in-out;
               margin-bottom: 20px;
            box-sizing: border-box;
           text-align: center;
    "  id="prompt" placeholder="Enter your prompt here" maxlength="500">A hyper realistic, highly detailed image of an old book mockup titled "The Secret Mindset Of Successful People". The book mockup should be placed on a natural bokeh background. In the footer of the book cover, include the Author name "AudioBook Legends" with an old typography which is clearly visible, also add relevant elements from title in the book cover.</textarea>
                           <div id="prompt-counter">0 / 500</div>
                            <div id="prompt-warning">Character limit exceeded.</div>
                           </div>
                    <div class="dimension-options">
                        <label for="dimensionPreset">Select Image Dimension:</label>
                            <select id="dimensionPreset">
                                <option value="custom">Custom Input</option>
                                 <option value="book">Book Mockup 1:1</option>
                                  <option value="thumbnail">Thumbnail 16:9</option>
                            </select>
                    </div>
               <div class="dimensions" style="display: flex; justify-content: center; align-items: center; margin-bottom: 15px;">
    <label for="width" style="margin-right: 5px;">Width:</label>
    <input type="number" id="width" placeholder="Width" value="1024" style="width: 80px; padding: 10px; margin: 0 5px; border: none; border-radius: 10px; box-sizing: border-box; background: #e0e0e0; box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff; outline: none;">
     <label for="height" style="margin-left: 5px; margin-right: 5px;">Height:</label>
    <input type="number" id="height" placeholder="Height" value="1024" style="width: 80px; padding: 10px; margin: 0 5px; border: none; border-radius: 10px; box-sizing: border-box; background: #e0e0e0; box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff; outline: none;">
</div>
                 <!-- Number of Images Select -->
                <div class="image-number-options">
                    <label for="numImages">Number of Images:</label>
                    <select id="numImages">
                        <option value="1">1</option>
                        <option value="2">2</option>
                        <option value="3">3</option>
                        <option value="4">4</option>
                        <option value="5">5</option>
                    </select>
                </div>
                <button type="submit">Generate Image</button>
                <div id="status"></div>
            </form>
            <div id="image-container" class="image-list"></div>
            <div id="history-container"></div>
        `;

        // Get a reference to the *newly created* elements
        promptTextarea = document.getElementById('prompt');
        promptCounter = document.getElementById('prompt-counter');
        promptWarning = document.getElementById('prompt-warning');
        widthInput = document.getElementById('width');
        heightInput = document.getElementById('height');
        dimensionPresetDropdown = document.getElementById('dimensionPreset');

        if (promptTextarea) {
            promptTextarea.addEventListener('input', updatePromptCounter);
            updatePromptCounter(); // Initial update
        }

        if(dimensionPresetDropdown){
            dimensionPresetDropdown.addEventListener('change', () => {
                updateDimensionInputs(dimensionPresetDropdown.value);
            });
            updateDimensionInputs(dimensionPresetDropdown.value); // Initial update
        }



        const userDetailsContainer = document.getElementById('user-details-container');
        const historyContainer = document.getElementById('history-container');
        //Fetch and Display user details
        function fetchAndDisplayUserDetails(){
            fetch('apis/getUserDetails.php?email=' + selectedEmail)
                .then(response => response.json())
                .then(data => {
                    if (data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json) {
                        const user = data[0].result.data.json;
                        const nextResetDate = new Date(user.next_reset_date);
                        const formattedResetDate = nextResetDate.toLocaleDateString(undefined, {
                            year: 'numeric',
                            month: 'long',
                            day: 'numeric',
                            hour: 'numeric',
                            minute: 'numeric'
                        });
                        const userDetailsHTML = `
                            <p><strong>Email:</strong> ${user.email}</p>
                            <p><strong>Credits Left:</strong> ${user.credits}</p>
                            <p><strong>Next Reset Date:</strong> ${formattedResetDate}</p><button id="login-btn" onclick="window.location.href='apis/authLoginWithPassword.php?email=${selectedEmail}'">Login</button>
                        `;
                        userDetailsContainer.innerHTML = userDetailsHTML;
                    } else {
                        userDetailsContainer.innerHTML = '<button id="login-btn" onclick="window.location.href=\'apis/authLoginWithPassword.php?email='+selectedEmail+'\'">Login</button>';
                    }
                })
                .catch(error => {
                    userDetailsContainer.innerHTML = '<button id="login-btn" onclick="window.location.href=\'apis/authLoginWithPassword.php?email='+selectedEmail+'\'">Login</button>';
                    console.error('Error:', error);
                });
        }
        fetchAndDisplayUserDetails();




        // Fetch and display image history on page load
        function fetchAndDisplayHistory() {
            fetch('apis/imageHistory.php?email=' + selectedEmail)
                .then(response => response.json())
                .then(data => {
                    if(data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json){
                        const history = data[0].result.data.json;
                        let historyHTML = '<ul>';
                        history.forEach(item => {
                            historyHTML += `<li>
                                    <div class="image-item-image"><img src="${item.s3_url}" alt="Generated Image"></div>
                                    <div class="image-item-details">
                                        <p><strong>Prompt:</strong> ${item.input_prompt}</p>
                                        <p><strong>Created At:</strong> ${item.created_at}</p>
                                        <div class="btn-container"><a class="download-btn" href="${item.s3_url}" download="image.jpg">Download</a></div>
                                    </div>
                                </li>`;
                        });
                        historyHTML += '</ul>';
                        historyContainer.innerHTML = historyHTML;
                    } else {
                        historyContainer.innerHTML = 'No images found in history.';
                    }

                })
                .catch(error=>{
                    historyContainer.innerHTML = 'Error fetching image history.';
                    console.error('Error:', error)
                });

        }
        fetchAndDisplayHistory();

        document.getElementById('imageForm').addEventListener('submit', function(event) {
            event.preventDefault();

            const prompt = document.getElementById('prompt').value;
            const width = document.getElementById('width').value;
            const height = document.getElementById('height').value;
            const numImages = parseInt(document.getElementById('numImages').value); // Get the selected number of images
            const statusDiv = document.getElementById('status');
            const imageContainer = document.getElementById('image-container');

            statusDiv.textContent = 'Generating...';
            imageContainer.innerHTML = '';

            let imagesGenerated = 0; // Track the number of images generated so far

            function generateImage() {
                fetch('apis/addTask.php?email=' + selectedEmail, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded',
                    },
                    body: 'prompt=' + encodeURIComponent(prompt) + '&width=' + encodeURIComponent(width) + '&height=' + encodeURIComponent(height),
                })
                    .then(response => response.json())
                    .then(data => {
                        if (data && data.error) {
                            statusDiv.textContent = 'Error: ' + data.error;
                        } else if (data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json && data[0].result.data.json[0]) {
                            const uuid = data[0].result.data.json[0].uuid;
                            // statusDiv.textContent = 'Status: ' + data[0].result.data.json[0].status; //initial status
                            // Start Polling function
                            pollForImage(uuid, statusDiv, imageContainer, selectedEmail, historyContainer, userDetailsContainer, () => {
                                imagesGenerated++; // Increment counter after successful generation
                                if (imagesGenerated < numImages) {
                                    generateImage(); // Call the function recursively
                                } else {
                                    statusDiv.textContent = 'All images generated successfully!';
                                }
                            });
                        } else {
                            statusDiv.textContent = 'Unknown error or may be image generated.';
                        }
                    })
                    .catch(error => {
                        statusDiv.textContent = 'Error generating image.';
                        console.error('Error:', error);
                    });
            }

            generateImage(); // Kick off the first image generation
        });
    }
    function pollForImage(uuid, statusDiv, imageContainer, email, historyContainer, userDetailsContainer, callback) { // Add callback
        let requestCount = 0; // Initialize request counter
        const interval = setInterval(() => {
            requestCount++; // Increment counter on each request
            fetch('apis/getTask.php?email=' + email, {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                },
                body: 'uuid=' + encodeURIComponent(uuid),
            })
                .then(response => response.json())
                .then(data => {
                    if (data && data.error) {
                        statusDiv.textContent = 'Error: ' + data.error;
                        clearInterval(interval);
                        callback(); // Execute callback even on error
                    } else if (data && data[0] && data[0].result && data[0].result.data && data[0].result.data.json && data[0].result.data.json[0]) {
                        const task = data[0].result.data.json[0];
                        if (task.status === 'processing') {
                             statusDiv.textContent = 'Processing... (Request #' + requestCount + ')';
                        } else if (task.status === 'completed' && task.s3_url) {
                            clearInterval(interval);
                             const imgElement = document.createElement('img');
                            imgElement.src = task.s3_url;
                            imgElement.alt = 'Generated Image';

                            // Add the new image to the *top* of the container
                            imageContainer.prepend(imgElement);
                            statusDiv.textContent = 'Image Generated Successfully';
                            fetchAndDisplayHistory();
                            fetchAndDisplayUserDetails();
                            callback(); // Execute callback on success

                        } else if (task.status === 'error') {
                            clearInterval(interval);
                            statusDiv.textContent = 'Error: ' + task.error_message;
                            callback(); // Execute callback even on error
                        }
                    } else {
                        statusDiv.textContent = 'Error generating image.';
                        clearInterval(interval);
                        callback(); // Execute callback even on error
                    }
                })
                .catch(error => {
                    statusDiv.textContent = 'Error generating image.';
                    clearInterval(interval);
                    console.error('Error:', error);
                    callback(); // Execute callback even on error
                });

        }, 1000); // Check every 1 second
    }
</script>
</body>
</html>